# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

BEGIN { $| = 1; print "1..23\n"; }
END {print "not ok 1\n" unless $loaded;}
use Gnokii::GSM;
$loaded = 1;
print "ok 1\n";

######################### End of black magic.

$gsm_conn = Gnokii::GSM->new("/dev/ttyS1","6150");

#$gsm_conn->GetPhonebook();
print "Status: ".$gsm_conn->{"Status"}."\n";
$j=1;
foreach $i (@{$gsm_conn->{"Phonebook"}})
{
    print "Name:\t$i->{'Name'} ";
    print "Number:\t$i->{'Number'} ";
    print "Index:\t$j ";
    print "Memory:\t$i->{'Memory'} ";
    print "Group: $i->{'Group'}\n";
    $j++
}
print "ok 2\n";
$gsm_conn->GetMemoryLocation(1, "SM");
print "Name:\t$gsm_conn->{'PBEntry'}->{'Name'} ";
print "Number:\t$gsm_conn->{'PBEntry'}->{'Number'} ";
print "Index:\t$i ";
print "Memory:\t$gsm_conn->{'PBEntry'}->{'Memory'} ";
print "Group: $gsm_conn->{'PBEntry'}->{'Group'}\n";
print "ok 3\n";
$gsm_conn->GetMemoryStatus();
print "A Free:$gsm_conn->{'Memory'}->{'A'}->{'Free'}\n";
print "ok 4\n";
$gsm_conn->GetSMSStatus();
print "SMS: Unread: $gsm_conn->{'SMSStatus'}->{'Unread'} Msgs: $gsm_conn->{'SMSStatus'}->{'Number'}\n";
print "ok 5\n";
$gsm_conn->GetSMSMessages();
print ($#{$gsm_conn->{"Messages"}}+1);
print " Messages read\n";
foreach $m(@{$gsm_conn->{"Messages"}})
{
    print "Date: ".localtime($m->{'Date'})." Length: $m->{'Length'} Val: $m->{'Validity'}\n";
    print "Msg: $m->{'MessageText'}\n";
    print "Centre: $m->{'MessageCenter'} Sender: $m->{'Sender'} Dest: $m->{'Destination'} Memory: $m->{'Memory'} Type: $m->{'Type'}\n";
    print "Status: $m->{'Status'} Class: $m->{'Class'} Eightbit: $m->{'EightBit'} Compression: $m->{'Compression'}\n";
}
print "ok 6\n";
if(($ret = $gsm_conn->GetRFLevel(0)) == 0)
{
    print "RFLevel: $gsm_conn->{'RFLevel'}\n";
    print "ok 7\n";
}
else
{
    print "RFLevel error $ret\n";
    print "failed 7\n";
}
if(($ret = $gsm_conn->GetBatteryLevel(0)) == 0)
{
    print "BatteryLevel: $gsm_conn->{'BatteryLevel'}\n";
    print "ok 8\n";
}
else
{
    print "BatteryLevel error $ret\n";
    print "failed 8\n";
}
$gsm_conn->GetPowerSource();
print "PowerSource: $gsm_conn->{'PowerSource'}\n";
print "ok 9\n";
$gsm_conn->GetDateTime();
print "Phonedate: ".localtime($gsm_conn->{"Date"})."\n";
print "ok 10\n";
$alindex=0;
$gsm_conn->GetAlarm($alindex);
if($gsm_conn->{"Alarms"}->[$alindex]->{"Enabled"} == 0)
{
    print "Alarm disabled\n";
}
else
{
    print "Alarm: ".localtime($gsm_conn->{"Alarms"}->[$alindex]->{"Date"})."\n";
    print "AlarmStatus $gsm_conn->{'Status'}\n";
}
print "ok 11\n";
$gsm_conn->GetIncomingCallNr();
print "Number: $gsm_conn->{'Number'} Error: $gsm_conn->{'Status'}\n";
print "ok 12\n";
print "Writing first Sim-Entry with name GNOKIITEST into Phone-Memory\n";
$pbentry = $gsm_conn->{"Phonebook"}->[0];
print "$pbentry->{'Name'} will be written, ok?";
$answer = <STDIN>;
chomp($answer);
if($answer eq "j")
{
    $pbentry->{"Name"} = "GNOKIITEST";
    $pbentry->{"Memory"} = "B";
    $code = $gsm_conn->WritePhonebookLocation($pbentry,130);
    print "ok 13\n" unless $code;
}
$msg = $gsm_conn->{"Messages"}->[2];
print "$msg->{'MessageText'} will be deleted ok?";
$answer = <STDIN>;
chomp($answer);
if($answer eq "j")
{
    $code = $gsm_conn->DeleteSMSMessage("B",3);
    print "ok 14\n" unless $code;
}

$msghash={};
print "Shall I send a SMS?";
$answer = <STDIN>;
chomp($answer);
if($answer eq "j")
{
    print "Please enter a Testmessage for sending SMS's:";
    $msghash->{"MessageText"}=<STDIN>;
    chomp($msghash->{"MessageText"});
    print "Please enter a Phonenumber to send it to:";
    $msghash->{"Destination"} = <STDIN>;
    chomp($msghash->{"Destination"});
    print "Please enter the MessageCenter-Number:";
    $msghash->{"MessageCentre"} = <STDIN>;
    chomp($msghash->{"MessageCentre"});
    if($gsm_conn->SendSMSMessage($msghash) == 14)
    {
	print "ok 15\n";
    }
    else
    {
	print "failed 15\n";
    }
}
print "Trying to enter Pin:";
$pin=<STDIN>;
chomp($pin);
if($retcode = $gsm_conn->EnterPin($pin))
{
    print "Error $retcode\n";
    print "failed 16\n";
}
else
{
    print "ok 16\n";
}

if($retcode = $gsm_conn->SetDateTime(time()))
{
    print "Error $retcode\n";
    print "Failed 17\n";
}
else
{
    print "ok 17\n";
}

$now=time();
$now+=60;
if($retcode=$gsm_conn->SetAlarm(0,$now))
{
    print "Error $retcode\n";
    print "Failed 18\n";
}
else
{
    print "ok 18\n";
}

print "Shall I dial voice?";
$answer=<STDIN>;
chomp($answer);
if($answer eq "y")
{
    print "Enter number to dial:";
    $number=<STDIN>;
    chomp($number);
    if($retcode=$gsm_conn->DialVoice($number))
    {
	print "Error $retcode\n";
	print "Failed 19\n";
    }
    else
    {
	print "ok 19\n";
    }
}

if(!($retcode = $gsm_conn->GetIMEI()))
{
  print "IMEI = $gsm_conn->{'IMEI'}\n";
  print "ok 20\n";
}
else
{
  print "Retcode: $retcode\n";
  print "failed 20\n";
}

if(!($retcode = $gsm_conn->GetRevision()))
{
  print "Revision = $gsm_conn->{'Revision'}\n";
  print "ok 21\n";
}
else
{
  print "Retcode: $retcode\n";
  print "failed 21\n";
}

if(!($retcode = $gsm_conn->GetModel()))
{
  print "Model = $gsm_conn->{'Model'}\n";
  print "ok 22\n";
}
else
{
  print "Retcode: $retcode\n";
  print "failed 22\n";
}

if(!($retcode = $gsm_conn->GetNetworkInfo()))
{
    print "NetworkCode: $gsm_conn->{'NetworkInfo'}->{'NetworkCode'}\n";
    print "CellID:      $gsm_conn->{'NetworkInfo'}->{'CellID'}\n";
    print "LAC:         $gsm_conn->{'NetworkInfo'}->{'LAC'}\n";
    print "ok 23\n";
}
else
{
    print "Retcode: $retcode\n";
    print "failed 23\n";
}

if(!($retcode = $gsm_conn->GetSMSCenter(1)))
{
    print "No    : $gsm_conn->{'SMSCenter'}->{'No'}\n";
    print "Name  : $gsm_conn->{'SMSCenter'}->{'Name'}\n";
    print "Number: $gsm_conn->{'SMSCenter'}->{'Number'}\n";
    print "ok 24\n";
}
else
{
    print "Retcode: $retcode\n";
    print "failed 24\n";
}
